"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MetricsDataSource = exports.ErrorEnum = void 0;
const apollo_datasource_1 = require("apollo-datasource");
const errors_1 = require("../errors");
var ErrorEnum;
(function (ErrorEnum) {
    ErrorEnum["NO_COLLECTOR"] = "Metrics are not enabled";
})(ErrorEnum = exports.ErrorEnum || (exports.ErrorEnum = {}));
class MetricsDataSource extends apollo_datasource_1.DataSource {
    constructor(_internalCollector) {
        super();
        this._internalCollector = _internalCollector;
    }
    getMetrics(queue, start, end) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this._collector.extract(queue, start, end);
        });
    }
    clearAllMetrics() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this._collector.clearAll();
            return true;
        });
    }
    clearMetrics(queue) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this._collector.clear(queue);
            return true;
        });
    }
    _throwInternalError(e) {
        throw new errors_1.BullMonitorError(e);
    }
    _throwNoCollector() {
        this._throwInternalError(ErrorEnum.NO_COLLECTOR);
    }
    get _collector() {
        if (!this._internalCollector) {
            this._throwNoCollector();
        }
        return this._internalCollector;
    }
}
exports.MetricsDataSource = MetricsDataSource;
//# sourceMappingURL=index.js.map